/* -*-C-*-
*******************************************************************************
*
* File:         tp.c
* RCS:          $Header: $
* Description:  Minimal Turbo Pascal compatibility routines for CHIPPER
* Author:       Darryl Okahata (darrylo@sr.hp.com)
* Created:      Sun Jul  7 02:11:48 1991
* Modified:     Mon Jul  8 19:41:44 1991 (Darryl Okahata) darrylo@hpsrdmo
* Language:     C
* Package:      CHIPPER
*
*******************************************************************************
*
* This file contains stub routines for Turbo Pascal's FExpand() and FSplit()
* procedures.  These routines were developed under Unix, and probably do not
* work under MSDOS (because of bugs), although an attempt was made to handle
* Unix <--> MSDOS differences (but this has never been tested).
*
* If this file is ever compiled under MSDOS, the symbol "MSDOS" must be
* defined.
*
*******************************************************************************
*/


#include <stdio.h>
#include <limits.h>
# ifndef PATH_MAX
#  define PATH_MAX	1024		/* pray */
# endif
#include <ctype.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#ifndef MSDOS
char	*getcwd();
#else
# include <dir.h>
#endif

char *FExpand(path)
char	*path;
{
	static char	result[PATH_MAX + 1];
	char		cwd[PATH_MAX + 1], *start, *resptr, *wrk;
	int		len;

	getcwd(cwd, PATH_MAX);
	if (*path == '\0') {
		strcpy(result, cwd);
		return (result);
	}
	resptr = result;
	if (isalpha(path[0]) && path[1] == ':') {
		*resptr++ == *path++;
		*resptr++ == *path++;
	}
	start = resptr;
	if (*path != '/' && *path != '\\') {
		for (wrk = cwd; *wrk; ) {
			*resptr++ = *wrk++;
		}
		*resptr++ = '/';
		*resptr = '\0';
	} else {
		*resptr++ = *path++;
	}
	while (*path) {
		if (*path == '/' || *path == '\\') {
			++path;
			continue;
		}
		if (*path == '.') {
			if (path[1] == '.' && (path[2] == '\0' ||
					       path[2] == '/' ||
					       path[2] == '\\')) {
				while (--resptr > start) {
					if (*resptr == '/' ||
					    *resptr == '\\') {
						break;
					}
				}
				++resptr;
			} else if (path[1] == '\0' ||
				   path[1] == '/' ||
				   path[1] == '\\') {
				++path;
				continue;
			}
		}
		while (*path && *path != '/' && *path != '\\' &&
		       *path != '\0') {
			*resptr++ = *path++;
		}
		if (*path) {
			*resptr++ = *path;
		}
	}
	*resptr = '\0';
	return (result);
}


FSplit(path, directory, name, extension)
char	*path, *directory, *name, *extension;
{
	struct stat	info;
	char		*cptr, *extptr;
	int		c, len;

	*directory = '\0';
	*name = '\0';
	*extension = '\0';
	if (*path == '\0') {
		return;
	}
	if ((stat(path, &info) == 0) && (info.st_mode & S_IFDIR)) {
		strcpy(directory, path);
		c = directory[strlen(directory) - 1];
		if (c != '/' && c != '\\') {
			strcat(directory, "/");
		}
		return;
	}
	if ((cptr = strrchr(path, '/')) == NULL &&
	    (cptr = strrchr(path, '\\')) == NULL) {
		strcpy(name, path);
		return;
	}
	len = cptr - path + 1;
	strncpy(directory, path, len);
	directory[len] = '\0';
	strcpy(name, cptr + 1);
	if ((extptr = strrchr(cptr + 1, '.')) == NULL) {
		return;
	}
	len = extptr - (cptr + 1);
	name[len] = '\0';
	strcpy(extension, extptr);
	return;
}
